<?php 

error_log("adhoc loaded");

global $URL_HANDLERS;
$URL_HANDLERS["adhoc.*"] = "GLCASAdhoc";
global $BASE_URL, $MENU_ITEMS;
$MENU_ITEMS["20adhoc"]["name"] = "Adhoc Packages";
$MENU_ITEMS["20adhoc"]["link"] = "$BASE_URL/adhoc";


class GLCASAdhoc {
	function __construct($config)
	{
		$this->config = $config;
		error_log("constructor for GLCASAdhoc");
		
		$repostore = $this->config->getConfig("storagelocation");
		if(!is_dir("$repostore/adhoc")) {
			error_log("Creating dir for adhoc component");
			mkdir("$repostore/adhoc");
		}
		
	}
	
	function go($url)
	{
		if(isset($_REQUEST["action"])) {
			switch($_REQUEST["action"]) {
				case "addpackage":
					error_log("in updaterepo");
					GLCASpageBuilder($this,"addPackage");
					return;
				case "deletepkg":
					error_log("in delete pkg");
					GLCASpageBuilder($this, "delPackage");
					return;
			}
		}
		
		GLCASpageBuilder($this,"mainBody");
		return;
		
	}
	
	function delPackage($url)
	{	
		$repostore = $this->config->getConfig("storagelocation");
		
		$pkgid = $_REQUEST["pkgid"];
		
		$pkgs = unserialize($this->config->getConfig("adhocpackages"));
		
		if(isset($pkgs[$pkgid])) {
			unset($pkgs[$pkgid]);
			$this->config->setConfig("adhocpackages", serialize($pkgs));
			$this->config->saveConfig();
		}
		
		global $WEB_ROOT_FS, $URL_HANDLERS, $BASE_URL;
		header("Location: $BASE_URL/adhoc/");
		
	}
	
	function addPackage($url)
	{
		$repostore = $this->config->getConfig("storagelocation");
		
		if(!isset($_REQUEST["pkgname"])) {
			echo "<font color=\"red\">Error: No package name set</font><br>";
		} 
		if($_REQUEST["pkgname"] == "") {
			echo "<font color=\"red\">Error: Package name cant be blank</font><br>";
		}
		

		$fname = "";
		$lname = "";
		$ultfileurl = "";
		if($_FILES["uploadedfile"]["name"] == "") {
			$uploaded = false;
			$ultfileurl = "uploaded";
		} else {
			$fname = $_FILES["uploadedfile"]["tmp_name"];
			$lname = $_FILES["uploadedfile"]["name"];
			$uploaded = true;
		}
		
		if($_REQUEST["fileurl"] == "") {
			$fileurl = false;
			$ultfileurl = $_REQUEST["fileurl"];
		} else {
			$fname = $_REQUEST["fileurl"];
			$lname = basename($fname);
			$fileurl = true;
		}
		
		if(!$uploaded && !$fileurl) {
			echo "<font color=\"red\">Error: no uploaded file and no file url, you need one or the other buddy</font><br>";
		}
		
		$getfile = "";
		if($fileurl) {
			$getfile = file_get_contents($_REQUEST["fileurl"]);
		}
		
		if($uploaded||$fileurl) {
			echo "Got a file named $fname, $lname";
		}
		
		$pkgs = unserialize($this->config->getConfig("adhocpackages"));
		
		$n = -1;
		foreach($pkgs as $key => $var) {
			$n = $key;
		}
		$n++;
		
		echo "Would add package as $n";
		
		$pkgs[$n]["name"] = $_REQUEST["pkgname"];
		$pkgs[$n]["arch"] = $_REQUEST["arch"];
		$pkgs[$n]["type"] = $_REQUEST["type"];
		$pkgs[$n]["fileurl"] = $ultfileurl;

		if($uploaded) {
			copy("$fname", "$repostore/adhoc/$n");
		} else {
			file_put_contents("$repostore/adhoc/$n", $fetfile);
		}
		
		$this->config->setConfig("adhocpackages", serialize($pkgs));
		$this->config->saveConfig();
		
		echo "Done";
		
		
		echo "<pre>";
		print_r($_SERVER);
		print_r($_FILES);
		print_r($_REQUEST);
		print_r($pkgs);
		echo "</pre>";
	}
	
	
	function mainBody($url)
	{
		echo "<h2>Packages</h2>";

		$pkgs = unserialize($this->config->getConfig("adhocpackages"));
		echo "<table border=\"1\"><tr><th>Name</th><th>Package Types</th><th>Architecture</th><th>Control</th></tr>";
		
		foreach($pkgs as $key => $var) {
			$name = $var["pkgname"];
			$arch = $var["arch"];
			$type = $var["type"];
			echo "<tr><td>$name</td><td>$type</td><td>$arch</td><td>Add another arch <a href=\"?action=deletepkg&pkgid=$key\">Delete</a></td></tr>";
		}
		echo "<table>";
		
		$kos = getKnownOSList();
		
		echo "<hr>";
		echo "<h3>Add a Package</h3><br>";
		echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"?action=addpackage\">";
		echo "Name <input type=\"text\" name=\"pkgname\"> or Add version of <select name=\"origpkg\"></select><br>";
		echo "Arch <select name=\"arch\">";
		foreach($kos["pkgarch"] as $key => $val) {
			echo "<option value=\"$key\">$val</option>";
		}
		echo "</select><br>";
		echo "Type <select name=\"type\">";
		foreach($kos["pkg"] as $key => $val) {
			echo "<option value=\"$key\">$val</option>";
		}
		echo "</select><br>";
		echo "Upload <input type=\"file\" name=\"uploadedfile\"><br>";
		echo "From URL <input type=\"text\" name=\"fileurl\"><br>";
		echo "<input type=\"submit\" name=\"add\" value=\"Add\">";
		echo "</form>";
	}
	
	private $config;
}

?>
